// Squawk messenger. 
// Copyright (C) 2019  Yury Gubich <blue@macaw.me>
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef UI_KEYDELEGATE_H
#define UI_KEYDELEGATE_H

#include <QStyledItemDelegate>
#include <QString>
#include <vector>

namespace UI {

class KeyDelegate : public QStyledItemDelegate
{
public:
    KeyDelegate(QObject *parent = nullptr);
    ~KeyDelegate();

    QSize sizeHint(const QStyleOptionViewItem & option, const QModelIndex & index) const override;
    void paint(QPainter* painter, const QStyleOptionViewItem& option, const QModelIndex& index) const override;

private:
    const QFont& defaultFont;
    const QFont& fingerPrintFont;
    const QFont& labelFont;
    const QFontMetrics& defaultMetrics;
    const QFontMetrics& fingerPrintMetrics;
    const QFontMetrics& labelMetrics;
    int spaceWidth;

private:
    static std::vector<QString> getParts(const QByteArray& data);
};

}

#endif // UI_KEYDELEGATE_H
